import {Action, Reducer} from 'redux';
import { DevelopStoreState } from './store';
import {DevelopActionType, DevelopSetTitle} from './actions';
import { BaseStoreState } from '../store';


function developSetTitle(state: BaseStoreState, action: DevelopSetTitle) {
    return {
        ...state,
        develop: {
            ...state.develop,
            title: action.title
        }
        
    }
}

const reducer: Reducer<BaseStoreState | undefined, Action> = (state: BaseStoreState | undefined, action: Action) => {
    if (!state) {
        return state;
    }

    switch (action.type) {
        case DevelopActionType.DEVELOP_SET_TITLE:
            return developSetTitle(state, action as DevelopSetTitle);
        default:
            return;
    }
}

export default reducer;
