import { AppStoreState, makeIntegrationStoreInitialState } from './integration/store';
import { AuthStoreState, makeAuthStoreInitialState } from './auth/store';
import { DevelopStoreState, makeDevelopStore } from './develop/store';

export interface BaseStoreState extends AppStoreState, AuthStoreState, DevelopStoreState {}

export function makeBaseStoreState(): BaseStoreState {
    const appStore = makeIntegrationStoreInitialState();
    const authStore = makeAuthStoreInitialState();
    const developStore = makeDevelopStore();
    return {
        ...appStore,
        ...authStore,
        ...developStore
    };
}

export interface AppError {
    code: string;
    message: string;
    generatedAt?: Date;
    trace?: Array<string>;
    errors?: Array<AppError>;
}
